package com.its.op.service.its.scrs;

import com.its.op.dao.repository.its.scrs.TbScTodCnfgRepository;
import com.its.op.dto.its.scrs.TbScTodCnfgDto;
import com.its.op.entity.its.scrs.TbScTodCnfg;
import com.its.op.entity.its.scrs.TbScTodCnfgKey;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.NoSuchElementException;
import java.util.Optional;

@Slf4j
@RequiredArgsConstructor
@Service
public class TbScTodCnfgService {

    private final TbScTodCnfgRepository repo;

    // 데이터 1건 조회, 없으면 exception
    private TbScTodCnfg requireOne(TbScTodCnfgKey sgnlIxrNmbr) throws NoSuchElementException {
        Optional<TbScTodCnfg> info = this.repo.findById(sgnlIxrNmbr);
        if (info.isPresent()) {
            return info.get();
        }
        else {
            throw new NoSuchElementException("데이터가 존재하지 않습니다: " + sgnlIxrNmbr);
        }
    }

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbScTodCnfgDto> findAll() {
        List<TbScTodCnfgDto> result = new ArrayList<>();
        List<TbScTodCnfg> data = this.repo.findAll();
        for (TbScTodCnfg entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbScTodCnfgDto> findAllList() {
        List<TbScTodCnfgDto> result = new ArrayList<>();
        List<TbScTodCnfg> data = this.repo.findAllList();
        for (TbScTodCnfg entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 데이터 1건 조회(기존 데이터가 반드시 존재해야 함)
    @Transactional(readOnly = true)
    public TbScTodCnfgDto findById(TbScTodCnfgKey sgnlIxrNmbr) {
        TbScTodCnfg entity = requireOne(sgnlIxrNmbr);
        return entity.toDto();
    }

    // 데이터 변경
    @Transactional
    public TbScTodCnfgDto updateById(TbScTodCnfgKey sgnlIxrNmbr, TbScTodCnfgDto.TbScTodCnfgUpdReq req) {
        TbScTodCnfg entity = requireOne(sgnlIxrNmbr);
        entity.updateInfo(req);
        this.repo.save(entity);
        return entity.toDto();
    }

    // 데이터 변경 또는 생성-목록(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public List<TbScTodCnfgDto> mergeInfoList(List<TbScTodCnfgDto.TbScTodCnfgUpdReq> reqList) {
        List<TbScTodCnfgDto> result = new ArrayList<>();
        for (TbScTodCnfgDto.TbScTodCnfgUpdReq req : reqList) {
            TbScTodCnfg obj = req.toEntity();
            this.repo.save(obj);
            result.add(obj.toDto());
        }
        return result;
    }

    // 데이터 변경 또는 생성-개별(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public TbScTodCnfgDto mergeInfo(TbScTodCnfgDto.TbScTodCnfgUpdReq req) {
        TbScTodCnfg obj = req.toEntity();
        this.repo.save(obj);
        return obj.toDto();
    }

    // 정보 삭제-개별, 데이터 존재하지 않으면 Exception
    @Transactional
    public TbScTodCnfgDto deleteById(TbScTodCnfgKey sgnlIxrNmbr) {
        TbScTodCnfg entity = requireOne(sgnlIxrNmbr);
        this.repo.deleteById(sgnlIxrNmbr);
        return entity.toDto();
    }

    // 정보 삭제-목록, 존재하는 데이터 만 삭제
    @Transactional
    public List<TbScTodCnfgDto> deleteByIds(List<TbScTodCnfgKey> ids) {
        List<TbScTodCnfgDto> result = new ArrayList<>();
        for (TbScTodCnfgKey id : ids) {
            Optional<TbScTodCnfg> obj = this.repo.findById(id);
            if (obj.isPresent()) {
                this.repo.deleteById(id);
                result.add(obj.get().toDto());
            }
        }
        return result;
    }

    @Transactional(readOnly = true)
    public List<TbScTodCnfgDto> findListById(Integer sgnlIxrNmbr, Integer ixrOperMode) {
        List<TbScTodCnfgDto> result = new ArrayList<>();
        List<TbScTodCnfg> data = this.repo.findListById(sgnlIxrNmbr, ixrOperMode);
        for (TbScTodCnfg entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }
}
